freight/urls.py
from django.conf.urls import url
from . import views

app_name = "freight"

urlpatterns = [
    url(r"^$", views.index, name="index"),
    url(
        r"^setup_contract_handler/$",
        views.setup_contract_handler,
        name="setup_contract_handler",
    ),
    url(r"^add_location/$", views.add_location, name="add_location"),
    url(r"^add_location_2/$", views.add_location_2, name="add_location_2"),
    url(r"^calculator/$", views.calculator, name="calculator"),
    url(r"^calculator/(?P<pricing_pk>[0-9]+)/$", views.calculator, name="calculator"),
    url(
        r"^contract_list_active/$",
        views.contract_list_active,
        name="contract_list_active",
    ),
    url(r"^contract_list_user/$", views.contract_list_user, name="contract_list_user"),
    url(
        r"^contract_list_data/(?P<category>.+)/$",
        views.contract_list_data,
        name="contract_list_data",
    ),
    url(r"^statistics/$", views.statistics, name="statistics"),
    url(
        r"^statistics_routes_data/$",
        views.statistics_routes_data,
        name="statistics_routes_data",
    ),
    url(
        r"^statistics_pilots_data/$",
        views.statistics_pilots_data,
        name="statistics_pilots_data",
    ),
    url(
        r"^statistics_pilot_corporations_data/$",
        views.statistics_pilot_corporations_data,
        name="statistics_pilot_corporations_data",
    ),
    url(
        r"^statistics_customer_data/$",
        views.statistics_customer_data,
        name="statistics_customer_data",
    ),
]

freight/forms.py
import math

from django import forms
from django.core.exceptions import ValidationError
from django.core.validators import MinValueValidator

from .models import Pricing


class CalculatorForm(forms.Form):
    pricing = forms.ModelChoiceField(
        queryset=Pricing.objects.filter(is_active=True).order_by(
            "start_location__name", "end_location__name"
        ),
        label="Route",
        help_text="Pick a route for your courier contract",
        empty_label=None,
    )
    volume = forms.IntegerField(
        help_text="Est. volume of your cargo in m3",
        required=False,
        validators=[MinValueValidator(0)],
    )
    collateral = forms.IntegerField(
        help_text=(
            "Collaterial in ISK, must be roughly equal to the est. "
            "value of your cargo"
        ),
        required=False,
        validators=[MinValueValidator(0)],
    )

    def clean(self):
        pricing = self.cleaned_data["pricing"]
        issue_prefix = "⚠ Issues:"

        if pricing.requires_volume() and self.cleaned_data["volume"] is None:
            raise ValidationError("{} volume is required".format(issue_prefix))

        if pricing.requires_collateral() and self.cleaned_data["collateral"] is None:
            raise ValidationError("{} collateral is required".format(issue_prefix))

        volume = self.cleaned_data["volume"]
        collateral = self.cleaned_data["collateral"]
        issues = pricing.get_contract_price_check_issues(volume, collateral)

        if issues:
            raise ValidationError("{} {}".format(issue_prefix, ", ".join(issues)))

    def get_calculated_data(self, pricing: object) -> tuple:
        if self.is_valid():
            if self.cleaned_data["volume"]:
                volume = int(self.cleaned_data["volume"])
            else:
                volume = 0
            if self.cleaned_data["collateral"]:
                collateral = int(self.cleaned_data["collateral"])
            else:
                collateral = 0
            price = (
                math.ceil(pricing.get_calculated_price(volume, collateral) / 1000000)
                * 1000000
            )

        else:
            volume = None
            collateral = None
            price = None

        return volume, collateral, price


class AddLocationForm(forms.Form):
    location_id = forms.IntegerField(
        label="Location ID",
        help_text="Eve Online ID for a station or an Upwell structure",
    )

freight/templates/freight/add_location.html
{% extends 'freight/base.html' %}
{% load i18n %}
{% load humanize %}
{% load bootstrap %}

{% block details %}
    <form class="form" action="{% url 'freight:add_location_2' %}" method="POST">
        {% csrf_token %}
        {{ form|bootstrap }}        
        <button class="btn btn-success btn-block" type="submit">Add / Update Location</button>
        <p class="text-muted">Accessing structures with token from <strong>{{ token_char_name }}</strong></p>
    </form>    
{% endblock %}

freight/templates/freight/calculator.html
{% extends 'freight/base.html' %}
{% load i18n %}
{% load humanize %}
{% load bootstrap %}
{% load static %}
{% load freight_filters %}

{% block details %}
    <form id="form_calculator" class="form" action="{% url 'freight:calculator' %}" method="POST">        
        {% csrf_token %}
        <div class="row">
            <div class="col-md-6">

                <div class="panel panel-primary">
                    <div class="panel-heading">
                        <h3 class="panel-title">Calculator</h3>
                    </div>
                    <div class="panel-body">
                        {{ form|bootstrap }}
                        <br>
                        <p><strong>Reward</strong></p>
                        <h2 id="text_price"> 
                            {{ price|formatnumber:"0"|default_if_none:"-" }} ISK
                        </h2>
                        
                        <button class="btn btn-success btn-lg" type="submit">Click To Calculate Reward!</button>
                    </div>
                </div>

            </div>
            <div class="col-md-6">                
                
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Pricing details</h3>
                    </div>
                    <div class="panel-body" style="min-height: 100px;">
                        
                        {% if pricing %}       
                            
                            <dl class="dl-horizontal">

                                {% if pricing.is_bidirectional %}
                                    <dt>From / To:</dt>
                                {% else %}
                                    <dt>From:</dt>
                                {% endif %}

                                <dd>{{ pricing.start_location }}</dd>

                                {% if pricing.is_bidirectional %}
                                    <dt>From / To:</dt>
                                {% else %}
                                    <dt>To:</dt>
                                {% endif %}
                                <dd>{{ pricing.end_location }}</dd>

                                <dt>Both directions:</dt>                                    
                                <dd>{{ pricing.is_bidirectional|yesno }}</dd>                                    
                                <br>

                                {% if pricing.price_min != None %}
                                    <dt>Minimum price:</dt>
                                    <dd>{{ pricing.price_min|formatnumber:"0" }} ISK</dd>
                                {% endif %}

                                {% if pricing.price_base != None %}
                                    {% if pricing.is_fix_price %}
                                        <dt>Fix price:</dt>
                                    {% else %}
                                        <dt>Base price:</dt>
                                    {% endif %}
                                    <dd>{{ pricing.price_base|formatnumber:"0" }} ISK</dd>
                                {% endif %}
                                
                                {% if pricing_price_per_volume_eff != None %}
                                    <dt>Price add-on per m3:</dt>
                                    <dd>{{ pricing_price_per_volume_eff|formatnumber:"0" }} ISK</dd>
                                {% endif %}

                                {% if pricing.price_per_collateral_percent != None %}
                                    <dt>Price add-on collateral:</dt>
                                    <dd>{{ pricing.price_per_collateral_percent }} %</dd>
                                {% endif %}

                                <br>
                                {% if pricing.volume_min != None %}
                                    <dt>Min Volume:</dt>
                                    <dd>{{ pricing.volume_min|formatnumber:"0"|default_if_none:"-" }} m3</dd>
                                {% endif %}
                                
                                {% if pricing.volume_max != None %}
                                    <dt>Max Volume:</dt>
                                    <dd>{{ pricing.volume_max|formatnumber:"0"|default_if_none:"-" }} m3</dd>
                                {% endif %}

                                {% if pricing.collateral_min != None %}
                                    <dt>Min. Collateral:</dt>
                                    <dd>{{ pricing.collateral_min|formatnumber:"0" }} ISK</dd>
                                {% endif %}

                                {% if pricing.collateral_max != None %}
                                    <dt>Max. Collateral:</dt>        
                                    <dd>{{ pricing.collateral_max|formatnumber:"0" }} ISK</dd>
                                {% endif %}

                                <br>

                                {% if pricing.details %}
                                    <dt>Additional Instructions:</dt>
                                    <dd>{{ pricing.details|linebreaks }}</dd>
                                {% endif %}

                            </dl>

                        {% else %}

                            <p class="text-muted">No pricing defined</p>

                        {% endif %}               

                    </div>
                </div> 

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Your contract</h3>
                    </div>
                    <div class="panel-body" style="min-height: 100px;">    

                        {% if price != None %}
                        
                            <dl class="dl-horizontal">

                                <dt>Contract Type:</dt>
                                <dd>Courier</dd>

                                <dt>Availability:</dt>
                                <dd>{{ availability }}</dd>

                                <dt>Location:</dt>
                                <dd>{{ pricing.start_location }}</dd>
                                
                                {% if pricing.days_to_expire %}
                                    <dt>Expiration:</dt>
                                    <dd>{{ pricing.days_to_expire }} days ({{ expires_on|date:'Y-m-d' }})</dd>
                                {% endif %}

                                <hr>
                                
                                <dt>Reward:</dt>
                                <dd>{{ price|formatnumber:"0"|default_if_none:"???" }} ISK</dd>

                                <dt>Collateral:</dt>
                                <dd>{{ collateral|formatnumber:"0"|default_if_none:"???" }} ISK</dd>

                                <dt>Destination:</dt>
                                <dd>{{ pricing.end_location }}</dd>

                                {% if pricing.days_to_complete %}
                                    <dt>Days to complete:</dt>           
                                    <dd>{{ pricing.days_to_complete|default_if_none:"-" }}</dd>
                                {% endif %}

                                {% if pricing.requires_volume %}
                                    <dt>Volume:</dt>
                                    <dd>{{ volume|formatnumber:"0"|default_if_none:"???" }} m3</dd>
                                {% endif %}

                                <hr>

                                Note that this route is bidirectional, so Location and Destination can be switched.

                            </dl>

                        {% else %}

                            <p class="text-muted">No price calculated yet</p>

                        {% endif %}

                    </div>
                </div>
                

            </div>
        </div>        
    </form>
<br>    
        
{% endblock %}

{% block extra_css %}    
    <link 
        href="{% static 'freight/calculator.css' %}" 
        type="text/css" 
        rel="stylesheet"
    >
{% endblock %}

{% block extra_script %}    
    $(document).ready(function(){                
        /* redirecting to updated calculator view with chosen pricing */
        $("#id_pricing").change(function(){            
            var value = $("#id_pricing").val();        
            if (value == null) { 
                value = 0;
            }
            window.location.replace(
                "{% url 'freight:calculator' 0 %}".replace("0", value)
            );
        });
    });
{% endblock %}

freight/templates/freight/contract_list.html
{% extends 'freight/base.html' %}
{% load i18n %}
{% load humanize %}
{% load static %}
{% load freight_filters %}

{% block details %}
    
    <div class="panel panel-primary">   
        <div class="panel-heading">
            <h3 class="panel-title">Courier Contracts</h3>
        </div>
        <div class="panel-body">        
            <div class="table-responsive">
                <table class="table table-striped" id="tab_contracts">
                    <thead>
                        <tr>
                            <th>Status</th>
                            <th>Start</th>
                            <th>Destination</th>                        
                            <th>Rew.<br>M&nbsp;ISK</th>
                            <th>Coll.<br>M&nbsp;ISK</th>
                            <th>Vol.<br>K&nbsp;m3</th>
                            <th>Contract Check</th>
                            <th>Issued<br>On</th>
                            <th>Expires<br>On</th>
                            <th>Issued<br>By</th>
                            <th>Notes</th>
                            <th>Accepted<br>On</th>
                            <th>Accepted<br>By</th>
                        </tr>
                    </thead>
                    <tbody>                   
                    </tbody>                
                </table>
            </div>
        </div>
    </div>    
    <p class="text-muted">
        Contract check:&nbsp;&nbsp; 
        <span class="glyphicon glyphicon-ok" aria-hidden="true"></span> = OK &nbsp;&nbsp; 
        <span class="glyphicon glyphicon-warning-sign" aria-hidden="true"></span> = Errors &nbsp;&nbsp;
        If they are errors you find them in the tooltip of icon &nbsp;&nbsp;
        <strong>-</strong> = No contract check performed
    </p>
    <p class="text-muted">
        Notes:&nbsp;&nbsp;
        <span class="glyphicon glyphicon-envelope" aria-hidden="true"></span> &nbsp;&nbsp;
        If icon is shown you can hover with the mouse over it to see the notes.
    </p>  
    
{% endblock %}

{% block extra_javascript %}
    {% include 'bundles/datatables-js.html' %}    
    
    <!--load JS for filterDropDown plugin -->
    <script type="text/javascript" src="{% static 'freight/filterDropDown.min.js' %}">
    </script>
{% endblock %}

{% block extra_css %}
    {% include 'bundles/datatables-css.html' %}    

    <link href="{% static 'freight/contracts.css' %}" type="text/css" rel="stylesheet">
{% endblock %}

{% block extra_script %}
    $(document).ready(function(){
        $('#tab_contracts').DataTable({            
            ajax: {
                url: '{% url 'freight:contract_list_data' category %}',
                dataSrc: '',
                cache: false
            },

            columns: [
                { data: 'status' },
                { data: 'start_location' },
                { data: 'end_location' },                
                { data: 'reward' },
                { data: 'collateral' },
                { data: 'volume' },
                { data: 'pricing_check' },
                { data: 'date_issued' },
                { data: 'date_expired' },
                { data: 'issuer' },
                { data: 'notes' },
                { data: 'date_accepted' },
                { data: 'acceptor' },
                
                /* hidden columns for filter */
                { data: 'route_name' }
            ],

            columnDefs: [														
                { "orderable": false, "targets": [ 6 ] },
                { "visible": false, "targets": [ 13 ] },
            ],

            order: [ [ 7, "desc" ] ],

            filterDropDown: {										
                columns: [	                                        
                    {
                        idx: 13,
                        title: 'Route'
                    },
                    {
                        idx: 0
                    },
                    {
                        idx: 9
                    },
                    {
                        idx: 12
                    }
                ],
                bootstrap: true
            },

            createdRow: function( row, data, dataIndex ) 
            {
                if (data['is_in_progress'])
                {
                    $(row).addClass('info');
                }
                else if (data['is_failed'])
                {
                    $(row).addClass('warning');
                }
                else if (data['is_completed'])
                {
                    $(row).addClass('success');
                }
            },
        });       
    });
{% endblock %}

freight/templates/freight/menu.html
{% load static %}
{% load i18n %}
{% load navactive %}

<nav class="navbar navbar-default">
    <div class="container-fluid">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
                <span class="sr-only">{% trans "Toggle navigation" %}</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="{% url 'freight:index' %}">{{ app_title }}</a>
        </div>
        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
            <ul class="nav navbar-nav">
                {% if perms.freight.use_calculator %}
                    <li class="{% navactive request 'freight:calculator' %}">
                        <a href="{% url 'freight:calculator' %}">Reward Calculator</a>
                    </li>
                    <li class="{% navactive request 'freight:contract_list_user' %}">
                        <a href="{% url 'freight:contract_list_user' %}">
                            My Contracts&nbsp;
                            {% if pending_user_count > 0 %}
                                <span class="badge">{{ pending_user_count }}</span>
                            {% endif %}
                        </a> 
                    </li>
                {% endif %}
                {% if perms.freight.view_contracts %}
                    <li class="{% navactive request 'freight:contract_list_active' %}">
                        <a href="{% url 'freight:contract_list_active' %}">
                            Active Contracts&nbsp;
                            {% if pending_all_count > 0 %}
                                <span class="badge">{{ pending_all_count }}</span>
                            {% endif %}
                        </a> 
                    </li>
                {% endif %}
                {% if perms.freight.view_statistics %}
                    <li class="{% navactive request 'freight:statistics' %}">
                        <a href="{% url 'freight:statistics' %}">
                            Statistics
                        </a> 
                    </li>
                {% endif %}
            </ul>
            <ul class="nav navbar-nav navbar-right"> 
                {% if perms.freight.add_location %}
                    <a class="btn btn-default navbar-btn" href="{% url 'freight:add_location' %}">
                        Add Location
                    </a>
                {% endif %}

                {% if perms.freight.setup_contract_handler %}
                    <a class="btn btn-default navbar-btn" href="{% url 'freight:setup_contract_handler' %}">
                        Setup Contract Handler
                    </a>
                {% endif %}                
            </ul>
        </div>
    </div>
</nav>

freight/templates/freight/statistics.html
{% extends 'freight/base.html' %}
{% load i18n %}
{% load humanize %}
{% load static %}
{% load freight_filters %}

{% block details %}
    
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">Routes</h3>
        </div>
        <div class="panel-body">        
            <div class="table-responsive">
                <table class="table table-striped" id="tab_routes">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Contracts</th>
                            <th>Rewards<br>M&nbsp;ISK</th>
                            <th>Collaterals<br>M&nbsp;ISK</th>
                            <th>Pilots</th>
                            <th>Customers</th>
                        </tr>
                    </thead>
                    <tbody>                   
                    </tbody> 
                    <tfoot>
                        <tr class="success">
                            <th>Totals</th>
                            <th></th>
                            <th></th>
                            <th></th>
                            <th></th>
                            <th></th>
                        </tr>
				</tfoot>              
                </table>
            </div>
        </div>
    </div>

    <div class="panel panel-primary">   
        <div class="panel-heading">
            <h3 class="panel-title">Pilots</h3>
        </div>
        <div class="panel-body">        
            <div class="table-responsive">
                <table class="table table-striped" id="tab_pilots">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Corporation</th>
                            <th>Contracts</th>
                            <th>Rewards<br>M&nbsp;ISK</th>
                            <th>Collaterals<br>M&nbsp;ISK</th>                     
                        </tr>
                    </thead>
                    <tbody>                   
                    </tbody>  
                     <tfoot>
                        <tr class="success">
                            <th>Totals</th>
                            <th></th>
                            <th></th>                           
                            <th></th>
                            <th></th>
                        </tr>
				    </tfoot>                 
                </table>
            </div>
        </div>
    </div>

    <div class="panel panel-primary">   
        <div class="panel-heading">
            <h3 class="panel-title">Pilot Corporations</h3>
        </div>
        <div class="panel-body">        
            <div class="table-responsive">
                <table class="table table-striped" id="tab_pilot_corporations">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Alliance</th>
                            <th>Contracts</th>
                            <th>Rewards<br>M&nbsp;ISK</th>
                            <th>Collaterals<br>M&nbsp;ISK</th>                     
                        </tr>
                    </thead>
                    <tbody>                   
                    </tbody>  
                     <tfoot>
                        <tr class="success">
                            <th>Totals</th>
                            <th></th>
                            <th></th>                           
                            <th></th>
                            <th></th>
                        </tr>
				    </tfoot>                 
                </table>
            </div>
        </div>
    </div>
    
    <div class="panel panel-primary">   
        <div class="panel-heading">
            <h3 class="panel-title">Customers</h3>
        </div>
        <div class="panel-body">        
            <div class="table-responsive">
                <table class="table table-striped" id="tab_customers">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Corporation</th>
                            <th>Contracts</th>
                            <th>Rewards<br>M&nbsp;ISK</th>
                            <th>Collaterals<br>M&nbsp;ISK</th>                     
                        </tr>
                    </thead>
                    <tbody>                   
                    </tbody>
                    <tfoot>
                    <tr class="success">
                        <th>Totals</th>
                        <th></th>
                        <th></th>                           
                        <th></th>
                        <th></th>
                    </tr>
                </tfoot>                
                </table>
            </div>
        </div>
    </div>

    <p class="text-muted">
        Statistics calculated for all contracts finished withn the last {{ max_days }} days
    </p>  
    
{% endblock %}

{% block extra_javascript %}
    {% include 'bundles/datatables-js.html' %}        
{% endblock %}

{% block extra_css %}
    {% include 'bundles/datatables-css.html' %}    

    <link href="{% static 'freight/statistics.css' %}" type="text/css" rel="stylesheet">
{% endblock %}

{% block extra_script %}
    
    // Remove the formatting to get integer data for summation
    function intVal(i) 
    {
        return typeof i === 'string' 
            ? i.replace(/[\$,]/g, '')*1 
            : typeof i === 'number' 
                ? i 
                : 0;
    };

    $(document).ready(function(){        
        $('#tab_routes').DataTable({
            ajax: {
                url: '{% url 'freight:statistics_routes_data' %}',
                dataSrc: '',
                cache: false
            },

            columns: [
                { data: 'name' },
                { data: 'contracts' },
                { data: 'rewards' },
                { data: 'collaterals' },
                { data: 'pilots' },
                { data: 'customers' }                
            ],

            order: [ [ 1, "desc" ], [ 2, "desc" ] ],

            footerCallback: function ( row, data, start, end, display )
            {
                var api = this.api(), data;
                        
                var total = [];
                for (i = 1; i < 6; i++)
                {
                    total[i] = api
                        .column( i )
                        .data()
                        .reduce( function (a, b) {
                            return intVal(a) + intVal(b);
                        }, 0 );
                }
                
                for (i = 1; i < 6; i++)
                {
                    $( api.column( i ).footer() ).html(total[i].toLocaleString());
                }
            }

        });

        $('#tab_pilots').DataTable({
            ajax: {
                url: '{% url 'freight:statistics_pilots_data' %}',
                dataSrc: '',
                cache: false
            },

            columns: [
                { data: 'name' },
                { data: 'corporation' },
                { data: 'contracts' },
                { data: 'rewards' },
                { data: 'collaterals' }              
            ],

            order: [ [ 2, "desc" ], [ 3, "desc" ] ],

            footerCallback: function ( row, data, start, end, display )
            {
                var api = this.api(), data;
                        
                var total = [];
                for (i = 2; i < 5; i++)
                {
                    total[i] = api
                        .column( i )
                        .data()
                        .reduce( function (a, b) {
                            return intVal(a) + intVal(b);
                        }, 0 );
                }
                
                for (i = 2; i < 5; i++)
                {
                    $( api.column( i ).footer() ).html(total[i].toLocaleString());
                }
            }

        });


       $('#tab_pilot_corporations').DataTable({
            ajax: {
                url: '{% url 'freight:statistics_pilot_corporations_data' %}',
                dataSrc: '',
                cache: false
            },

            columns: [
                { data: 'name' },
                { data: 'alliance' },
                { data: 'contracts' },
                { data: 'rewards' },
                { data: 'collaterals' }              
            ],

            order: [ [ 2, "desc" ], [ 3, "desc" ] ],

            footerCallback: function ( row, data, start, end, display )
            {
                var api = this.api(), data;
                        
                var total = [];
                for (i = 2; i < 5; i++)
                {
                    total[i] = api
                        .column( i )
                        .data()
                        .reduce( function (a, b) {
                            return intVal(a) + intVal(b);
                        }, 0 );
                }
                
                for (i = 2; i < 5; i++)
                {
                    $( api.column( i ).footer() ).html(total[i].toLocaleString());
                }
            }

        });


        $('#tab_customers').DataTable({
            ajax: {
                url: '{% url 'freight:statistics_customer_data' %}',
                dataSrc: '',
                cache: false
            },

            columns: [
                { data: 'name' },
                { data: 'corporation' },
                { data: 'contracts' },
                { data: 'rewards' },
                { data: 'collaterals' }              
            ],

            order: [ [ 2, "desc" ], [ 3, "desc" ] ],

            footerCallback: function ( row, data, start, end, display )
            {
                var api = this.api(), data;
                        
                var total = [];
                for (i = 2; i < 5; i++)
                {
                    total[i] = api
                        .column( i )
                        .data()
                        .reduce( function (a, b) {
                            return intVal(a) + intVal(b);
                        }, 0 );
                }
                
                for (i = 2; i < 5; i++)
                {
                    $( api.column( i ).footer() ).html(total[i].toLocaleString());
                }
            }

        });
    });
{% endblock %}